﻿using UnityEngine;

namespace paint
{
    public class mech : MonoBehaviour
    {

        private GameObject hand;

        private GameObject handGlow;

        public void Awake()
        {
            hand = gameObject;

            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("ham.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f,  0f, 0f, 1f);
            handSprite.sortingLayerName = "Top";
        }

        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 1f)
            {
                        var arm1 = other.gameObject.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = other.gameObject.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = other.gameObject.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = other.gameObject.transform.Find("BackArm").Find("LowerArm");
                        var head = other.gameObject.transform.Find("Head");
                        var upper = other.gameObject.transform.Find("Body").Find("UpperBody");
                        var middle = other.gameObject.transform.Find("Body").Find("MiddleBody");
                        var lower = other.gameObject.transform.Find("Body").Find("LowerBody");
                        var fl1 = other.gameObject.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = other.gameObject.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = other.gameObject.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = other.gameObject.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = other.gameObject.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = other.gameObject.transform.Find("BackLeg").Find("Foot");
			    fl1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    lower.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    upper.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
            }
            else
            {
                        var arm1 = other.gameObject.transform.Find("FrontArm").Find("LowerArmFront");
                        var ar1 = other.gameObject.transform.Find("FrontArm").Find("UpperArmFront");
                        var ar2 = other.gameObject.transform.Find("BackArm").Find("UpperArm");
                        var arm2 = other.gameObject.transform.Find("BackArm").Find("LowerArm");
                        var head = other.gameObject.transform.Find("Head");
                        var upper = other.gameObject.transform.Find("Body").Find("UpperBody");
                        var middle = other.gameObject.transform.Find("Body").Find("MiddleBody");
                        var lower = other.gameObject.transform.Find("Body").Find("LowerBody");
                        var fl1 = other.gameObject.transform.Find("FrontLeg").Find("UpperLegFront");
                        var fl2 = other.gameObject.transform.Find("FrontLeg").Find("LowerLegFront");
                        var fl3 = other.gameObject.transform.Find("FrontLeg").Find("FootFront");
                        var l1 = other.gameObject.transform.Find("BackLeg").Find("UpperLeg");
                        var l2 = other.gameObject.transform.Find("BackLeg").Find("LowerLeg");
                        var l3 = other.gameObject.transform.Find("BackLeg").Find("Foot");
			    fl1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    fl3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    l3.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    middle.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    lower.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar1.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    ar2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    arm2.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
			    upper.gameObject.GetComponent<PhysicalBehaviour>().Disintegrate();
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= 5f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 250f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0f);
            }
        }
    }
}